# coding: utf-8

"""
Payment API

API for accepting payments and storing subscriptions

The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import (
    BaseModel,
    ConfigDict,
    Field,
    StrictBool,
    StrictFloat,
    StrictInt,
    StrictStr,
)
from typing import Any, ClassVar, Dict, List, Optional, Union
from crypticorn.pay.client.models.scope import Scope
from typing import Optional, Set
from typing_extensions import Self


class Product(BaseModel):
    """
    Model for reading a product
    """  # noqa: E501

    id: StrictStr = Field(description="UID of the model")
    created_at: StrictInt = Field(description="Timestamp of creation")
    updated_at: StrictInt = Field(description="Timestamp of last update")
    name: StrictStr = Field(description="Product name")
    price: Union[StrictFloat, StrictInt] = Field(description="Product price")
    scopes: Optional[List[Scope]]
    duration: StrictInt = Field(
        description="Product duration in days. 0 means forever."
    )
    description: StrictStr = Field(description="Product description")
    is_active: StrictBool = Field(description="Product is active")
    images: Optional[List[StrictStr]]
    original_price: Optional[Union[StrictFloat, StrictInt]]
    __properties: ClassVar[List[str]] = [
        "id",
        "created_at",
        "updated_at",
        "name",
        "price",
        "scopes",
        "duration",
        "description",
        "is_active",
        "images",
        "original_price",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Product from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if scopes (nullable) is None
        # and model_fields_set contains the field
        if self.scopes is None and "scopes" in self.model_fields_set:
            _dict["scopes"] = None

        # set to None if images (nullable) is None
        # and model_fields_set contains the field
        if self.images is None and "images" in self.model_fields_set:
            _dict["images"] = None

        # set to None if original_price (nullable) is None
        # and model_fields_set contains the field
        if self.original_price is None and "original_price" in self.model_fields_set:
            _dict["original_price"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Product from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "id": obj.get("id"),
                "created_at": obj.get("created_at"),
                "updated_at": obj.get("updated_at"),
                "name": obj.get("name"),
                "price": obj.get("price"),
                "scopes": obj.get("scopes"),
                "duration": obj.get("duration"),
                "description": obj.get("description"),
                "is_active": obj.get("is_active"),
                "images": obj.get("images"),
                "original_price": obj.get("original_price"),
            }
        )
        return _obj
